#!/bin/bash -ex


SRC=`pwd`
DEB=$SRC/../
gitversion=`git log --pretty=oneline | awk 'NR==1{print $1}' | cut -b '1-8'`
uname=`uname -r`
NAME=kmod-kgwttm-$gitversion

cat > config.h << EOF
#ifndef _CONFIG_H__
#define _CONFIG_H__

#define UBUNTU_KERNEL

#endif
EOF

make clean
KERNEL=$uname make
cd $DEB
mkdir -p $NAME/DEBIAN
cd $NAME/DEBIAN
touch control


cat > control << EOF
Package: kmod-kgwttm
description: When needed Kingsoft Physical LB, use this kmod
maintainer: xulingyu@kingsoft.com;hepeng@kingsoft.com
version: 0.1-$gitversion
Architecture: all
EOF

cat > postinst << EOF
#!/bin/bash

has_ttm=`cat /etc/modules | grep kgwttm`

if [ ! -n "$has_ttm" ]; then
    echo "kgwttm" >> /etc/modules
fi

kernel=`uname -r`
if [[ '$kernel' == $uname ]]; then
    depmod -aeF /boot/System.map-$uname $uname
    modprobe kgwttm 
fi
EOF
chmod +x postinst


cat > postrm << EOF
#!/bin/bash

sed -e '/kgwttm/d' -i /etc/modules 

kernel=`uname -r`
if [[ '$kernel' == $uname ]]; then
    depmod -aeF /boot/System.map-$uname $uname
fi
EOF
chmod +x postrm

cat > prerm << EOF
#!/bin/bash
kmod=`lsmod | grep kgwttm`
if [[ -n "$kmod" ]]; then
    modprobe -r kgwttm
fi
EOF

chmod +x prerm


cd $DEB/$NAME
mkdir -p lib/modules/$uname/kernel/net/
cp $SRC/kgwttm.ko lib/modules/$uname/kernel/net/

cd ..; dpkg -b $NAME
